#include<avr/io.h>
#include <util/twi.h>
#include<avr/interrupt.h>

#define TWIM_LESEN       1
#define TWIM_SCHREIBEN   0


int main()
{
    uint8_t zahl = 0;

    DDRB |= 0b00001100;
    DDRB &= 0b11111100;

    sei();
    cli();
    //Initialisierung der Schnittstelle:

    //bertragungsrate auf 23040Hz setzen (s.o.)
    TWBR = 48;
    TWSR = 1;    

    //Eigene Slave-Ansprechadresse einstellen, Achtung: linkshift ntig!
	TWAR = (1 << 1);

    //TWI aktivieren:
	TWCR = (1<<TWEN)|(1<<TWEA);

    while(true)
    {
        if(TWCR & (1<<TWINT))
        {
//ohne Ack:
  	        TWCR = (1<<TWINT)|(1<<TWEN);
	        while (!(TWCR & (1<<TWINT)));
	        zahl =  TWDR;
//Stop:
           TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO)|(1<<TWEA);
        }

        //Zahl anzeigen: (0 bis 3 mglich):
        if(zahl%2>0)
            PORTB |=0b00000100;
        else
            PORTB &=0b11111011;

        if((zahl/2)%2>0)
            PORTB |=0b00001000;
        else
            PORTB &=0b11110111;
    }
}
