#include<avr/io.h>
#include <util/twi.h>
#include<avr/interrupt.h>

#define TWIM_LESEN       1
#define TWIM_SCHREIBEN   0

void fehler()
{
    unsigned long pause = 0;
    PORTB &=0b11110111;
    PORTB |=0b00000100;
    for(pause=0;pause<10000000;pause++);
    PORTB &=0b11111011;
    PORTB |=0b00001000;
    for(pause=0;pause<10000000;pause++);
}

int main()
{
    uint8_t zahl = 0;
    uint8_t akku;

    DDRB |= 0b00001100;
    DDRB &= 0b11111100;

    sei();
    cli();
    //Initialisierung der Schnittstelle:

    //bertragungsrate auf 23040Hz setzen (s.o.)
    TWBR = 48;
    TWSR = 1;    

    while(true)
    {

        akku = PINB;
        //Taster 1: von Slave 1 Zahl lesen
        if( (akku & 0b00000001) > 0 )
        {
            while( (akku & 0b00000001) > 0 )
                akku = PINB;

//Start
            TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
//Warten
            while (!(TWCR & (1<<TWINT)));


//Adresse und Modus (lesen oder schreiben)
//            TWDR = 1<<1 | TWIM_LESEN; //schreiben setzen und Adresse==1 auswhlen
            TWDR = 3;
//auslsen Adresse und Modus senden
            TWCR = (1<<TWINT) | (1<<TWEN);
//Warten
            while (!(TWCR & (1<<TWINT)));

//Daten empfangen auslsen
            TWCR = (1<<TWINT) | (1<<TWEN);
//Warten
            while (!(TWCR & (1<<TWINT)));
//empfangenes Byte speichern.
            zahl = TWDR;

//STOP
            TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
        }


        //Zahl anzeigen: (0 bis 3 mglich):
        if(zahl%2>0)
            PORTB |=0b00000100;
        else
            PORTB &=0b11111011;

        if((zahl/2)%2>0)
            PORTB |=0b00001000;
        else
            PORTB &=0b11110111;
    }
}
